[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 1. Synopsis

    ffplay [options] ‘input_file’

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 2. Description

FFplay is a very simple and portable media player using the FFmpeg libraries and the SDL library. It is mostly used as a testbed for the various FFmpeg APIs.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 3. Options

All the numerical options, if not specified otherwise, accept in input a string representing a number, which may contain one of the International System number postfixes, for example 'K', 'M', 'G'. If 'i' is appended after the postfix, powers of 2 are used instead of powers of 10. The 'B' postfix multiplies the value for 8, and can be appended after another postfix or used alone. This allows using for example 'KB', 'MiB', 'G' and 'B' as postfix.

Options which do not take arguments are boolean options, and set the corresponding value to true. They can be set to false by prefixing with "no" the option name, for example using "-nofoo" in the commandline will set to false the boolean option with name "foo".

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 3.1 Generic options

These options are shared amongst the ff* tools.

‘`-L`’

  Show license.

‘`-h, -?, -help, --help`’

  Show help.

‘`-version`’

  Show version.

‘`-formats`’

  Show available formats.

  The fields preceding the format names have the following meanings:

  ‘`D`’

    Decoding available

  ‘`E`’

    Encoding available

‘`-codecs`’

  Show available codecs.

  The fields preceding the codec names have the following meanings:

  ‘`D`’

    Decoding available

  ‘`E`’

    Encoding available

  ‘`V/A/S`’

    Video/audio/subtitle codec

  ‘`S`’

    Codec supports slices

  ‘`D`’

    Codec supports direct rendering

  ‘`T`’

    Codec can handle input truncated at random locations instead of only at frame boundaries

‘`-bsfs`’

  Show available bitstream filters.

‘`-protocols`’

  Show available protocols.

‘`-filters`’

  Show available libavfilter filters.

‘`-pix_fmts`’

  Show available pixel formats.

‘`-loglevel loglevel`’

  Set the logging level used by the library. loglevel is a number or a string containing one of the following values:

  ‘`quiet`’
  ‘`panic`’
  ‘`fatal`’
  ‘`error`’
  ‘`warning`’
  ‘`info`’
  ‘`verbose`’
  ‘`debug`’

  By default the program logs to stderr, if coloring is supported by the terminal, colors are used to mark errors and warnings. Log coloring can be disabled setting the environment variable `FFMPEG_FORCE_NOCOLOR` or `NO_COLOR`, or can be forced setting the environment variable `FFMPEG_FORCE_COLOR`. The use of the environment variable `NO_COLOR` is deprecated and will be dropped in a following FFmpeg version.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 3.2 Main options

‘`-x width`’

  Force displayed width.

‘`-y height`’

  Force displayed height.

‘`-s size`’

  Set frame size (WxH or abbreviation), needed for videos which don't contain a header with the frame size like raw YUV.

‘`-an`’

  Disable audio.

‘`-vn`’

  Disable video.

‘`-ss pos`’

  Seek to a given position in seconds.

‘`-t duration`’

  play <duration> seconds of audio/video

‘`-bytes`’

  Seek by bytes.

‘`-nodisp`’

  Disable graphical display.

‘`-f fmt`’

  Force format.

‘`-window_title title`’

  Set window title (default is the input filename).

‘`-loop number`’

  Loops movie playback <number> times. 0 means forever.

‘`-vf filter_graph`’

  filter_graph is a description of the filter graph to apply to the input video. Use the option "-filters" to show all the available filters (including also sources and sinks).

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 3.3 Advanced options

‘`-pix_fmt format`’

  Set pixel format.

‘`-stats`’

  Show the stream duration, the codec parameters, the current position in the stream and the audio/video synchronisation drift.

‘`-debug`’

  Print specific debug info.

‘`-bug`’

  Work around bugs.

‘`-vismv`’

  Visualize motion vectors.

‘`-fast`’

  Non-spec-compliant optimizations.

‘`-genpts`’

  Generate pts.

‘`-rtp_tcp`’

  Force RTP/TCP protocol usage instead of RTP/UDP. It is only meaningful if you are streaming with the RTSP protocol.

‘`-sync type`’

  Set the master clock to audio (`type=audio`), video (`type=video`) or external (`type=ext`). Default is audio. The master clock is used to control audio-video synchronization. Most media players use audio as master clock, but in some cases (streaming or high quality broadcast) it is necessary to change that. This option is mainly used for debugging purposes.

‘`-threads count`’

  Set the thread count.

‘`-ast audio_stream_number`’

  Select the desired audio stream number, counting from 0. The number refers to the list of all the input audio streams. If it is greater than the number of audio streams minus one, then the last one is selected, if it is negative the audio playback is disabled.

‘`-vst video_stream_number`’

  Select the desired video stream number, counting from 0. The number refers to the list of all the input video streams. If it is greater than the number of video streams minus one, then the last one is selected, if it is negative the video playback is disabled.

‘`-sst subtitle_stream_number`’

  Select the desired subtitle stream number, counting from 0. The number refers to the list of all the input subtitle streams. If it is greater than the number of subtitle streams minus one, then the last one is selected, if it is negative the subtitle rendering is disabled.

‘`-autoexit`’

  Exit when video is done playing.

‘`-exitonkeydown`’

  Exit if any key is pressed.

‘`-exitonmousedown`’

  Exit if any mouse button is pressed.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 3.4 While playing

<q, ESC>

  Quit.

<f>

  Toggle full screen.

<p, SPC>

  Pause.

<a>

  Cycle audio channel.

<v>

  Cycle video channel.

<t>

  Cycle subtitle channel.

<w>

  Show audio waves.

<left/right>

  Seek backward/forward 10 seconds.

<down/up>

  Seek backward/forward 1 minute.

<mouse click>

  Seek to percentage in file corresponding to fraction of width.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 4. Expression Evaluation

When evaluating an arithemetic expression, FFmpeg uses an internal formula evaluator, implemented through the ‘`libavutil/eval.h`’ interface.

An expression may contain unary, binary operators, constants, and functions.

Two expressions expr1 and expr2 can be combined to form another expression "expr1;expr2". expr1 and expr2 are evaluated in turn, and the new expression evaluates to the value of expr2.

The following binary operators are available: `+`, `-`, `*`, `/`, `^`.

The following unary operators are available: `+`, `-`.

The following functions are available:

‘`sinh(x)`’
‘`cosh(x)`’
‘`tanh(x)`’
‘`sin(x)`’
‘`cos(x)`’
‘`tan(x)`’
‘`atan(x)`’
‘`asin(x)`’
‘`acos(x)`’
‘`exp(x)`’
‘`log(x)`’
‘`abs(x)`’
‘`squish(x)`’
‘`gauss(x)`’
‘`isnan(x)`’

  Return 1.0 if x is NAN, 0.0 otherwise.

‘`mod(x, y)`’
‘`max(x, y)`’
‘`min(x, y)`’
‘`eq(x, y)`’
‘`gte(x, y)`’
‘`gt(x, y)`’
‘`lte(x, y)`’
‘`lt(x, y)`’
‘`st(var, expr)`’

  Allow to store the value of the expression expr in an internal variable. var specifies the number of the variable where to store the value, and it is a value ranging from 0 to 9. The function returns the value stored in the internal variable.

‘`ld(var)`’

  Allow to load the value of the internal variable with number var, which was previosly stored with st(var, expr). The function returns the loaded value.

‘`while(cond, expr)`’

  Evaluate expression expr while the expression cond is non-zero, and returns the value of the last expr evaluation, or NAN if cond was always false.

Note that:

`*` works like AND

`+` works like OR

thus

    if A then B else C

is equivalent to

    A*B + not(A)*C

When A evaluates to either 1 or 0, that is the same as

    A*B + eq(A,0)*C

In your C code, you can extend the list of unary and binary functions, and define recognized constants, so that they are available for your expressions.

The evaluator also recognizes the International System number postfixes. If 'i' is appended after the postfix, powers of 2 are used instead of powers of 10. The 'B' postfix multiplies the value for 8, and can be appended after another postfix or used alone. This allows using for example 'KB', 'MiB', 'G' and 'B' as postfix.

Follows the list of available International System postfixes, with indication of the corresponding powers of 10 and of 2.

‘`y`’

  -24 / -80

‘`z`’

  -21 / -70

‘`a`’

  -18 / -60

‘`f`’

  -15 / -50

‘`p`’

  -12 / -40

‘`n`’

  -9 / -30

‘`u`’

  -6 / -20

‘`m`’

  -3 / -10

‘`c`’

  -2

‘`d`’

  -1

‘`h`’

  2

‘`k`’

  3 / 10

‘`K`’

  3 / 10

‘`M`’

  6 / 20

‘`G`’

  9 / 30

‘`T`’

  12 / 40

‘`P`’

  15 / 40

‘`E`’

  18 / 50

‘`Z`’

  21 / 60

‘`Y`’

  24 / 70

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 5. Demuxers

Demuxers are configured elements in FFmpeg which allow to read the multimedia streams from a particular type of file.

When you configure your FFmpeg build, all the supported demuxers are enabled by default. You can list all available ones using the configure option "–list-demuxers".

You can disable all the demuxers using the configure option "–disable-demuxers", and selectively enable a single demuxer with the option "–enable-demuxer=DEMUXER", or disable it with the option "–disable-demuxer=DEMUXER".

The option "-formats" of the ff* tools will display the list of enabled demuxers.

The description of some of the currently available demuxers follows.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 5.1 image2

Image file demuxer.

This demuxer reads from a list of image files specified by a pattern.

The filename of each file to read must contain a sequential number, which specifies the position of the file in the sequence.

The pattern must contain the string "%d" or "%0Nd", which specifies the position of the characters representing the seqential number in each filename matched by the pattern. If the form "%d0Nd" is used, the string representing the number in each filename is 0-padded and N is the total number of 0-padded digits representing the number. The literal character '%' can be specified in the pattern with the string "%%".

The first filename of the file sequence specified by the pattern must contain a number inclusively contained between 0 and 4, all the following numbers must be sequential.

The pattern may contain a suffix which is used to automatically determine the format of the images contained in the files.

For example the pattern "img-%03d.bmp" will match a sequence of filenames of the form ‘`img-001.bmp`’, ‘`img-002.bmp`’, ..., ‘`img-010.bmp`’, etc.; the pattern "i%%m%%g-%d.jpg" will match a sequence of filenames of the form ‘`i%m%g-1.jpg`’, ‘`i%m%g-2.jpg`’, ..., ‘`i%m%g-10.jpg`’, etc.

The size, the pixel format, and the format of each image must be the same for all the files in the sequence.

The following example shows how to use ‘`ffmpeg`’ for creating a video from the images in the file sequence ‘`img-001.jpeg`’, ‘`img-002.jpeg`’, ..., assuming an input framerate of 10 frames per second:

    ffmpeg -r 10 -f image2 -i 'img-%03d.jpeg' out.avi

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 6. Input Devices

Input devices are configured elements in FFmpeg which allow to access the data coming from a multimedia device attached to your system.

When you configure your FFmpeg build, all the supported input devices are enabled by default. You can list all available ones using the configure option "–list-indevs".

You can disable all the input devices using the configure option "–disable-indevs", and selectively enable an input device using the option "–enable-indev=INDEV", or you can disable a particular input device using the option "–disable-indev=INDEV".

The option "-formats" of the ff* tools will display the list of supported input devices (amongst the demuxers).

A description of the currently available input devices follows.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 6.1 alsa

ALSA (Advanced Linux Sound Architecture) input device.

To enable this input device during configuration you need libasound installed on your system.

This device allows capturing from an ALSA device. The name of the device to capture has to be an ALSA card identifier.

An ALSA identifier has the syntax:

    hw:CARD[,DEV[,SUBDEV]]

where the DEV and SUBDEV components are optional.

The three arguments (in order: CARD,DEV,SUBDEV) specify card number or identifier, device number and subdevice number (-1 means any).

To see the list of cards currently recognized by your system check the files ‘`/proc/asound/cards`’ and ‘`/proc/asound/devices`’.

For example to capture with ‘`ffmpeg`’ from an ALSA device with card id 0, you may run the command:

    ffmpeg -f alsa -i hw:0 alsaout.wav

For more information see: http://www.alsa-project.org/alsa-doc/alsa-lib/pcm.html

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 6.2 bktr

BSD video input device.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 6.3 dv1394

Linux DV 1394 input device.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 6.4 jack

JACK input device.

To enable this input device during configuration you need libjack installed on your system.

A JACK input device creates one or more JACK writable clients, one for each audio channel, with name client_name:input_N, where client_name is the name provided by the application, and N is a number which identifies the channel. Each writable client will send the acquired data to the FFmpeg input device.

Once you have created one or more JACK readable clients, you need to connect them to one or more JACK writable clients.

To connect or disconnect JACK clients you can use the ‘`jack_connect`’ and ‘`jack_disconnect`’ programs, or do it through a graphical interface, for example with ‘`qjackctl`’.

To list the JACK clients and their properties you can invoke the command ‘`jack_lsp`’.

Follows an example which shows how to capture a JACK readable client with ‘`ffmpeg`’.

    # Create a JACK writable client with name "ffmpeg".
    $ ffmpeg -f jack -i ffmpeg -y out.wav

    # Start the sample jack_metro readable client.
    $ jack_metro -b 120 -d 0.2 -f 4000

    # List the current JACK clients.
    $ jack_lsp -c
    system:capture_1
    system:capture_2
    system:playback_1
    system:playback_2
    ffmpeg:input_1
    metro:120_bpm

    # Connect metro to the ffmpeg writable client.
    $ jack_connect metro:120_bpm ffmpeg:input_1

For more information read: http://jackaudio.org/

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 6.5 libdc1394

IIDC1394 input device, based on libdc1394 and libraw1394.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 6.6 oss

Open Sound System input device.

The filename to provide to the input device is the device node representing the OSS input device, and is usually set to ‘`/dev/dsp`’.

For example to grab from ‘`/dev/dsp`’ using ‘`ffmpeg`’ use the command:

    ffmpeg -f oss -i /dev/dsp /tmp/oss.wav

For more information about OSS see: http://manuals.opensound.com/usersguide/dsp.html

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 6.7 video4linux and video4linux2

Video4Linux and Video4Linux2 input video devices.

The name of the device to grab is a file device node, usually Linux systems tend to automatically create such nodes when the device (e.g. an USB webcam) is plugged into the system, and has a name of the kind ‘`/dev/videoN`’, where N is a number associated to the device.

Video4Linux and Video4Linux2 devices only support a limited set of widthxheight sizes and framerates. You can check which are supported for example with the command ‘`dov4l`’ for Video4Linux devices and the command ‘`v4l-info`’ for Video4Linux2 devices.

If the size for the device is set to 0x0, the input device will try to autodetect the size to use. Only for the video4linux2 device, if the frame rate is set to 0/0 the input device will use the frame rate value already set in the driver.

Video4Linux support is deprecated since Linux 2.6.30, and will be dropped in later versions.

Follow some usage examples of the video4linux devices with the ff* tools.

    # Grab and show the input of a video4linux device, frame rate is set
    # to the default of 25/1.
    ffplay -s 320x240 -f video4linux /dev/video0

    # Grab and show the input of a video4linux2 device, autoadjust size.
    ffplay -f video4linux2 /dev/video0

    # Grab and record the input of a video4linux2 device, autoadjust size,
    # frame rate value defaults to 0/0 so it is read from the video4linux2
    # driver.
    ffmpeg -f video4linux2 -i /dev/video0 out.mpeg

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 6.8 vfwcap

VfW (Video for Windows) capture input device.

The filename passed as input is the capture driver number, ranging from 0 to 9. You may use "list" as filename to print a list of drivers. Any other filename will be interpreted as device number 0.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 6.9 x11grab

X11 video input device.

This device allows to capture a region of an X11 display.

The filename passed as input has the syntax:

    [hostname]:display_number.screen_number[+x_offset,y_offset]

hostname:display_number.screen_number specifies the X11 display name of the screen to grab from. hostname can be ommitted, and defaults to "localhost". The environment variable `DISPLAY` contains the default display name.

x_offset and y_offset specify the offsets of the grabbed area with respect to the top-left border of the X11 screen. They default to 0.

Check the X11 documentation (e.g. man X) for more detailed information.

Use the ‘`dpyinfo`’ program for getting basic information about the properties of your X11 display (e.g. grep for "name" or "dimensions").

For example to grab from ‘`:0.0`’ using ‘`ffmpeg`’:

    ffmpeg -f x11grab -r 25 -s cif -i :0.0 out.mpg

    # Grab at position 10,20.
    ffmpeg -f x11grab -25 -s cif -i :0.0+10,20 out.mpg

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 7. Output Devices

Output devices are configured elements in FFmpeg which allow to write multimedia data to an output device attached to your system.

When you configure your FFmpeg build, all the supported output devices are enabled by default. You can list all available ones using the configure option "–list-outdevs".

You can disable all the output devices using the configure option "–disable-outdevs", and selectively enable an output device using the option "–enable-outdev=OUTDEV", or you can disable a particular input device using the option "–disable-outdev=OUTDEV".

The option "-formats" of the ff* tools will display the list of enabled output devices (amongst the muxers).

A description of the currently available output devices follows.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.1 alsa

ALSA (Advanced Linux Sound Architecture) output device.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.2 oss

OSS (Open Sound System) output device.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 8. Protocols

Protocols are configured elements in FFmpeg which allow to access resources which require the use of a particular protocol.

When you configure your FFmpeg build, all the supported protocols are enabled by default. You can list all available ones using the configure option "–list-protocols".

You can disable all the protocols using the configure option "–disable-protocols", and selectively enable a protocol using the option "–enable-protocol=PROTOCOL", or you can disable a particular protocol using the option "–disable-protocol=PROTOCOL".

The option "-protocols" of the ff* tools will display the list of supported protocols.

A description of the currently available protocols follows.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 8.1 concat

Physical concatenation protocol.

Allow to read and seek from many resource in sequence as if they were a unique resource.

A URL accepted by this protocol has the syntax:

    concat:URL1|URL2|...|URLN

where URL1, URL2, ..., URLN are the urls of the resource to be concatenated, each one possibly specifying a distinct protocol.

For example to read a sequence of files ‘`split1.mpeg`’, ‘`split2.mpeg`’, ‘`split3.mpeg`’ with ‘`ffplay`’ use the command:

    ffplay concat:split1.mpeg\|split2.mpeg\|split3.mpeg

Note that you may need to escape the character "|" which is special for many shells.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 8.2 file

File access protocol.

Allow to read from or read to a file.

For example to read from a file ‘`input.mpeg`’ with ‘`ffmpeg`’ use the command:

    ffmpeg -i file:input.mpeg output.mpeg

The ff* tools default to the file protocol, that is a resource specified with the name "FILE.mpeg" is interpreted as the URL "file:FILE.mpeg".

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 8.3 gopher

Gopher protocol.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 8.4 http

HTTP (Hyper Text Transfer Protocol).

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 8.5 mmst

MMS (Microsoft Media Server) protocol over TCP.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 8.6 mmsh

MMS (Microsoft Media Server) protocol over HTTP.

The required syntax is:

    mmsh://server[:port][/app][/playpath]

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 8.7 md5

MD5 output protocol.

Computes the MD5 hash of the data to be written, and on close writes this to the designated output or stdout if none is specified. It can be used to test muxers without writing an actual file.

Some examples follow.

    # Write the MD5 hash of the encoded AVI file to the file output.avi.md5.
    ffmpeg -i input.flv -f avi -y md5:output.avi.md5

    # Write the MD5 hash of the encoded AVI file to stdout.
    ffmpeg -i input.flv -f avi -y md5:

Note that some formats (typically MOV) require the output protocol to be seekable, so they will fail with the MD5 output protocol.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 8.8 pipe

UNIX pipe access protocol.

Allow to read and write from UNIX pipes.

The accepted syntax is:

    pipe:[number]

number is the number corresponding to the file descriptor of the pipe (e.g. 0 for stdin, 1 for stdout, 2 for stderr). If number is not specified, by default the stdout file descriptor will be used for writing, stdin for reading.

For example to read from stdin with ‘`ffmpeg`’:

    cat test.wav | ffmpeg -i pipe:0
    # ...this is the same as...
    cat test.wav | ffmpeg -i pipe:

For writing to stdout with ‘`ffmpeg`’:

    ffmpeg -i test.wav -f avi pipe:1 | cat > test.avi
    # ...this is the same as...
    ffmpeg -i test.wav -f avi pipe: | cat > test.avi

Note that some formats (typically MOV), require the output protocol to be seekable, so they will fail with the pipe output protocol.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 8.9 rtmp

Real-Time Messaging Protocol.

The Real-Time Messaging Protocol (RTMP) is used for streaming multime‐ dia content across a TCP/IP network.

The required syntax is:

    rtmp://server[:port][/app][/playpath]

The accepted parameters are:

‘`server`’

  The address of the RTMP server.

‘`port`’

  The number of the TCP port to use (by default is 1935).

‘`app`’

  It is the name of the application to access. It usually corresponds to the path where the application is installed on the RTMP server (e.g. ‘`/ondemand/`’, ‘`/flash/live/`’, etc.).

‘`playpath`’

  It is the path or name of the resource to play with reference to the application specified in app, may be prefixed by "mp4:".

For example to read with ‘`ffplay`’ a multimedia resource named "sample" from the application "vod" from an RTMP server "myserver":

    ffplay rtmp://myserver/vod/sample

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 8.10 rtmp, rtmpe, rtmps, rtmpt, rtmpte

Real-Time Messaging Protocol and its variants supported through librtmp.

Requires the presence of the librtmp headers and library during configuration. You need to explicitely configure the build with "–enable-librtmp". If enabled this will replace the native RTMP protocol.

This protocol provides most client functions and a few server functions needed to support RTMP, RTMP tunneled in HTTP (RTMPT), encrypted RTMP (RTMPE), RTMP over SSL/TLS (RTMPS) and tunneled variants of these encrypted types (RTMPTE, RTMPTS).

The required syntax is:

    rtmp_proto://server[:port][/app][/playpath] options

where rtmp_proto is one of the strings "rtmp", "rtmpt", "rtmpe", "rtmps", "rtmpte", "rtmpts" corresponding to each RTMP variant, and server, port, app and playpath have the same meaning as specified for the RTMP native protocol. options contains a list of space-separated options of the form key=val.

See the librtmp manual page (man 3 librtmp) for more information.

For example, to stream a file in real-time to an RTMP server using ‘`ffmpeg`’:

    ffmpeg -re -i myfile -f flv rtmp://myserver/live/mystream

To play the same stream using ‘`ffplay`’:

    ffplay "rtmp://myserver/live/mystream live=1"

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 8.11 rtp

Real-Time Protocol.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 8.12 rtsp

RTSP is not technically a protocol handler in libavformat, it is a demuxer and muxer. The demuxer supports both normal RTSP (with data transferred over RTP; this is used by e.g. Apple and Microsoft) and Real-RTSP (with data transferred over RDT).

The muxer can be used to send a stream using RTSP ANNOUNCE to a server supporting it (currently Darwin Streaming Server and Mischa Spiegelmock's RTSP server, http://github.com/revmischa/rtsp-server).

The required syntax for a RTSP url is:

    rtsp://hostname[:port]/path[?options]

options is a `&`-separated list. The following options are supported:

‘`udp`’

  Use UDP as lower transport protocol.

‘`tcp`’

  Use TCP (interleaving within the RTSP control channel) as lower transport protocol.

‘`multicast`’

  Use UDP multicast as lower transport protocol.

‘`http`’

  Use HTTP tunneling as lower transport protocol, which is useful for passing proxies.

‘`filter_src`’

  Accept packets only from negotiated peer address and port.

Multiple lower transport protocols may be specified, in that case they are tried one at a time (if the setup of one fails, the next one is tried). For the muxer, only the `tcp` and `udp` options are supported.

When receiving data over UDP, the demuxer tries to reorder received packets (since they may arrive out of order, or packets may get lost totally). In order for this to be enabled, a maximum delay must be specified in the `max_delay` field of AVFormatContext.

When watching multi-bitrate Real-RTSP streams with ‘`ffplay`’, the streams to display can be chosen with `-vst` n and `-ast` n for video and audio respectively, and can be switched on the fly by pressing `v` and `a`.

Example command lines:

To watch a stream over UDP, with a max reordering delay of 0.5 seconds:

    ffplay -max_delay 500000 rtsp://server/video.mp4?udp

To watch a stream tunneled over HTTP:

    ffplay rtsp://server/video.mp4?http

To send a stream in realtime to a RTSP server, for others to watch:

    ffmpeg -re -i input -f rtsp -muxdelay 0.1 rtsp://server/live.sdp

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 8.13 sap

Session Announcement Protocol (RFC 2974). This is not technically a protocol handler in libavformat, it is a muxer and demuxer. It is used for signalling of RTP streams, by announcing the SDP for the streams regularly on a separate port.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

### 8.13.1 Muxer

The syntax for a SAP url given to the muxer is:

    sap://destination[:port][?options]

The RTP packets are sent to destination on port port, or to port 5004 if no port is specified. options is a `&`-separated list. The following options are supported:

‘`announce_addr=address`’

  Specify the destination IP address for sending the announcements to. If omitted, the announcements are sent to the commonly used SAP announcement multicast address 224.2.127.254 (sap.mcast.net), or ff0e::2:7ffe if destination is an IPv6 address.

‘`announce_port=port`’

  Specify the port to send the announcements on, defaults to 9875 if not specified.

‘`ttl=ttl`’

  Specify the time to live value for the announcements and RTP packets, defaults to 255.

‘`same_port=0|1`’

  If set to 1, send all RTP streams on the same port pair. If zero (the default), all streams are sent on unique ports, with each stream on a port 2 numbers higher than the previous. VLC/Live555 requires this to be set to 1, to be able to receive the stream. The RTP stack in libavformat for receiving requires all streams to be sent on unique ports.

Example command lines follow.

To broadcast a stream on the local subnet, for watching in VLC:

    ffmpeg -re -i input -f sap sap://224.0.0.255?same_port=1

Similarly, for watching in ffplay:

    ffmpeg -re -i input -f sap sap://224.0.0.255

And for watching in ffplay, over IPv6:

    ffmpeg -re -i input -f sap sap://[ff0e::1:2:3:4]

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

### 8.13.2 Demuxer

The syntax for a SAP url given to the demuxer is:

    sap://[address][:port]

address is the multicast address to listen for announcements on, if omitted, the default 224.2.127.254 (sap.mcast.net) is used. port is the port that is listened on, 9875 if omitted.

The demuxers listens for announcements on the given address and port. Once an announcement is received, it tries to receive that particular stream.

Example command lines follow.

To play back the first stream announced on the normal SAP multicast address:

    ffplay sap://

To play back the first stream announced on one the default IPv6 SAP multicast address:

    ffplay sap://[ff0e::2:7ffe]

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 8.14 tcp

Trasmission Control Protocol.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 8.15 udp

User Datagram Protocol.

The required syntax for a UDP url is:

    udp://hostname:port[?options]

options contains a list of &-seperated options of the form key=val. Follow the list of supported options.

‘`buffer_size=size`’

  set the UDP buffer size in bytes

‘`localport=port`’

  override the local UDP port to bind with

‘`pkt_size=size`’

  set the size in bytes of UDP packets

‘`reuse=1|0`’

  explicitly allow or disallow reusing UDP sockets

‘`ttl=ttl`’

  set the time to live value (for multicast only)

‘`connect=1|0`’

  Initialize the UDP socket with `connect()`. In this case, the destination address can't be changed with udp_set_remote_url later. If the destination address isn't known at the start, this option can be specified in udp_set_remote_url, too. This allows finding out the source address for the packets with getsockname, and makes writes return with AVERROR(ECONNREFUSED) if "destination unreachable" is received. For receiving, this gives the benefit of only receiving packets from the specified peer address/port.

Some usage examples of the udp protocol with ‘`ffmpeg`’ follow.

To stream over UDP to a remote endpoint:

    ffmpeg -i input -f format udp://hostname:port

To stream in mpegts format over UDP using 188 sized UDP packets, using a large input buffer:

    ffmpeg -i input -f mpegts udp://hostname:port?pkt_size=188&buffer_size=65535

To receive over UDP from a remote endpoint:

    ffmpeg -i udp://[multicast-address]:port

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 9. Filtergraph description

A filtergraph is a directed graph of connected filters. It can contain cycles, and there can be multiple links between a pair of filters. Each link has one input pad on one side connecting it to one filter from which it takes its input, and one output pad on the other side connecting it to the one filter accepting its output.

Each filter in a filtergraph is an instance of a filter class registered in the application, which defines the features and the number of input and output pads of the filter.

A filter with no input pads is called a "source", a filter with no output pads is called a "sink".

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 9.1 Filtergraph syntax

A filtergraph can be represented using a textual representation, which is recognized by the `-vf` and `-af` options of the ff* tools, and by the `av_parse_graph()` function defined in ‘`libavfilter/avfiltergraph`’.

A filterchain consists of a sequence of connected filters, each one connected to the previous one in the sequence. A filterchain is represented by a list of ","-separated filter descriptions.

A filtergraph consists of a sequence of filterchains. A sequence of filterchains is represented by a list of ";"-separated filterchain descriptions.

A filter is represented by a string of the form: [in_link_1]...[in_link_N]filter_name=arguments[out_link_1]...[out_link_M]

filter_name is the name of the filter class of which the described filter is an instance of, and has to be the name of one of the filter classes registered in the program. The name of the filter class is optionally followed by a string "=arguments".

arguments is a string which contains the parameters used to initialize the filter instance, and are described in the filter descriptions below.

The list of arguments can be quoted using the character "'" as initial and ending mark, and the character '\' for escaping the characters within the quoted text; otherwise the argument string is considered terminated when the next special character (belonging to the set "[]=;,") is encountered.

The name and arguments of the filter are optionally preceded and followed by a list of link labels. A link label allows to name a link and associate it to a filter output or input pad. The preceding labels in_link_1 ... in_link_N, are associated to the filter input pads, the following labels out_link_1 ... out_link_M, are associated to the output pads.

When two link labels with the same name are found in the filtergraph, a link between the corresponding input and output pad is created.

If an output pad is not labelled, it is linked by default to the first unlabelled input pad of the next filter in the filterchain. For example in the filterchain:

    nullsrc, split[L1], [L2]overlay, nullsink

the split filter instance has two output pads, and the overlay filter instance two input pads. The first output pad of split is labelled "L1", the first input pad of overlay is labelled "L2", and the second output pad of split is linked to the second input pad of overlay, which are both unlabelled.

In a complete filterchain all the unlabelled filter input and output pads must be connected. A filtergraph is considered valid if all the filter input and output pads of all the filterchains are connected.

Follows a BNF description for the filtergraph syntax:

    NAME             ::= sequence of alphanumeric characters and '_'
    LINKLABEL        ::= "[" NAME "]"
    LINKLABELS       ::= LINKLABEL [LINKLABELS]
    FILTER_ARGUMENTS ::= sequence of chars (eventually quoted)
    FILTER           ::= [LINKNAMES] NAME ["=" ARGUMENTS] [LINKNAMES]
    FILTERCHAIN      ::= FILTER [,FILTERCHAIN]
    FILTERGRAPH      ::= FILTERCHAIN [;FILTERGRAPH]

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 10. Audio Filters

When you configure your FFmpeg build, you can disable any of the existing filters using –disable-filters. The configure output will show the audio filters included in your build.

Below is a description of the currently available audio filters.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 10.1 anull

Pass the audio source unchanged to the output.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 11. Audio Sources

Below is a description of the currently available audio sources.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 11.1 anullsrc

Null audio source, never return audio frames. It is mainly useful as a template and to be employed in analysis / debugging tools.

It accepts as optional parameter a string of the form sample_rate:channel_layout.

sample_rate specify the sample rate, and defaults to 44100.

channel_layout specify the channel layout, and can be either an integer or a string representing a channel layout. The default value of channel_layout is 3, which corresponds to CH_LAYOUT_STEREO.

Check the channel_layout_map definition in ‘`libavcodec/audioconvert.c`’ for the mapping between strings and channel layout values.

Follow some examples:

    #  set the sample rate to 48000 Hz and the channel layout to CH_LAYOUT_MONO.
    anullsrc=48000:4

    # same as
    anullsrc=48000:mono

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 12. Audio Sinks

Below is a description of the currently available audio sinks.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 12.1 anullsink

Null audio sink, do absolutely nothing with the input audio. It is mainly useful as a template and to be employed in analysis / debugging tools.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 13. Video Filters

When you configure your FFmpeg build, you can disable any of the existing filters using –disable-filters. The configure output will show the video filters included in your build.

Below is a description of the currently available video filters.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.1 blackframe

Detect frames that are (almost) completely black. Can be useful to detect chapter transitions or commercials. Output lines consist of the frame number of the detected frame, the percentage of blackness, the position in the file if known or -1 and the timestamp in seconds.

In order to display the output lines, you need to set the loglevel at least to the AV_LOG_INFO value.

The filter accepts the syntax:

    blackframe[=amount:[threshold]]

amount is the percentage of the pixels that have to be below the threshold, and defaults to 98.

threshold is the threshold below which a pixel value is considered black, and defaults to 32.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.2 copy

Copy the input source unchanged to the output. Mainly useful for testing purposes.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.3 crop

Crop the input video to out_w:out_h:x:y.

The parameters are expressions containing the following constants:

‘`E, PI, PHI`’

  the corresponding mathematical approximated values for e (euler number), pi (greek PI), PHI (golden ratio)

‘`x, y`’

  the computed values for x and y. They are evaluated for each new frame.

‘`in_w, in_h`’

  the input width and heigth

‘`iw, ih`’

  same as in_w and in_h

‘`out_w, out_h`’

  the output (cropped) width and heigth

‘`ow, oh`’

  same as out_w and out_h

‘`n`’

  the number of input frame, starting from 0

‘`pos`’

  the position in the file of the input frame, NAN if unknown

‘`t`’

  timestamp expressed in seconds, NAN if the input timestamp is unknown

The out_w and out_h parameters specify the expressions for the width and height of the output (cropped) video. They are evaluated just at the configuration of the filter.

The default value of out_w is "in_w", and the default value of out_h is "in_h".

The expression for out_w may depend on the value of out_h, and the expression for out_h may depend on out_w, but they cannot depend on x and y, as x and y are evaluated after out_w and out_h.

The x and y parameters specify the expressions for the position of the top-left corner of the output (non-cropped) area. They are evaluated for each frame. If the evaluated value is not valid, it is approximated to the nearest valid value.

The default value of x is "(in_w-out_w)/2", and the default value for y is "(in_h-out_h)/2", which set the cropped area at the center of the input image.

The expression for x may depend on y, and the expression for y may depend on x.

Follow some examples:

    # crop the central input area with size 100x100
    crop=100:100

    # crop the central input area with size 2/3 of the input video
    "crop=2/3*in_w:2/3*in_h"

    # crop the input video central square
    crop=in_h

    # delimit the rectangle with the top-left corner placed at position
    # 100:100 and the right-bottom corner corresponding to the right-bottom
    # corner of the input image.
    crop=in_w-100:in_h-100:100:100

    # crop 10 pixels from the left and right borders, and 20 pixels from
    # the top and bottom borders
    "crop=in_w-2*10:in_h-2*20"

    # keep only the bottom right quarter of the input image
    "crop=in_w/2:in_h/2:in_w/2:in_h/2"

    # crop height for getting Greek harmony
    "crop=in_w:1/PHI*in_w"

    # trembling effect
    "crop=in_w/2:in_h/2:(in_w-out_w)/2+((in_w-out_w)/2)*sin(n/10):(in_h-out_h)/2 +((in_h-out_h)/2)*sin(n/7)"

    # erratic camera effect depending on timestamp
    "crop=in_w/2:in_h/2:(in_w-out_w)/2+((in_w-out_w)/2)*sin(t*10):(in_h-out_h)/2 +((in_h-out_h)/2)*sin(t*13)"

    # set x depending on the value of y
    "crop=in_w/2:in_h/2:y:10+10*sin(n/10)"

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.4 cropdetect

Auto-detect crop size.

Calculate necessary cropping parameters and prints the recommended parameters through the logging system. The detected dimensions correspond to the non-black area of the input video.

It accepts the syntax:

    cropdetect[=limit[:round[:reset]]]

‘`limit`’

  Threshold, which can be optionally specified from nothing (0) to everything (255), defaults to 24.

‘`round`’

  Value which the width/height should be divisible by, defaults to 16. The offset is automatically adjusted to center the video. Use 2 to get only even dimensions (needed for 4:2:2 video). 16 is best when encoding to most video codecs.

‘`reset`’

  Counter that determines after how many frames cropdetect will reset the previously detected largest video area and start over to detect the current optimal crop area. Defaults to 0.

  This can be useful when channel logos distort the video area. 0 indicates never reset and return the largest area encountered during playback.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.5 drawbox

Draw a colored box on the input image.

It accepts the syntax:

    drawbox=x:y:width:height:color

‘`x, y`’

  Specify the top left corner coordinates of the box. Default to 0.

‘`width, height`’

  Specify the width and height of the box, if 0 they are interpreted as the input width and height. Default to 0.

‘`color`’

  Specify the color of the box to write, it can be the name of a color (case insensitive match) or a 0xRRGGBB[AA] sequence.

Follow some examples:

    # draw a black box around the edge of the input image
    drawbox

    # draw a box with color red and an opacity of 50%
    drawbox=10:20:200:60:red@0.5"

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.6 fifo

Buffer input images and send them when they are requested.

This filter is mainly useful when auto-inserted by the libavfilter framework.

The filter does not take parameters.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.7 format

Convert the input video to one of the specified pixel formats. Libavfilter will try to pick one that is supported for the input to the next filter.

The filter accepts a list of pixel format names, separated by ":", for example "yuv420p:monow:rgb24".

Some examples follow:

    # convert the input video to the format "yuv420p"
    format=yuv420p

    # convert the input video to any of the formats in the list
    format=yuv420p:yuv444p:yuv410p

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.8 frei0r

Apply a frei0r effect to the input video.

To enable compilation of this filter you need to install the frei0r header and configure FFmpeg with –enable-frei0r.

The filter supports the syntax:

    filter_name[{:|=}param1:param2:...:paramN]

filter_name is the name to the frei0r effect to load. If the environment variable `FREI0R_PATH` is defined, the frei0r effect is searched in each one of the directories specified by the colon separated list in `FREIOR_PATH`, otherwise in the standard frei0r paths, which are in this order: ‘`HOME/.frei0r-1/lib/`’, ‘`/usr/local/lib/frei0r-1/`’, ‘`/usr/lib/frei0r-1/`’.

param1, param2, ... , paramN specify the parameters for the frei0r effect.

A frei0r effect parameter can be a boolean (whose values are specified with "y" and "n"), a double, a color (specified by the syntax R/G/B, R, G, and B being float numbers from 0.0 to 1.0) or by an `av_parse_color()` color description), a position (specified by the syntax X/Y, X and Y being float numbers) and a string.

The number and kind of parameters depend on the loaded effect. If an effect parameter is not specified the default value is set.

Some examples follow:

    # apply the distort0r effect, set the first two double parameters
    frei0r=distort0r:0.5:0.01

    # apply the colordistance effect, takes a color as first parameter
    frei0r=colordistance:0.2/0.3/0.4
    frei0r=colordistance:violet
    frei0r=colordistance:0x112233

    # apply the perspective effect, specify the top left and top right
    # image positions
    frei0r=perspective:0.2/0.2:0.8/0.2

For more information see: http://piksel.org/frei0r

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.9 gradfun

Fix the banding artifacts that are sometimes introduced into nearly flat regions by truncation to 8bit colordepth. Interpolate the gradients that should go where the bands are, and dither them.

The filter takes two optional parameters, separated by ':': strength:radius

strength is the maximum amount by which the filter will change any one pixel. Also the threshold for detecting nearly flat regions. Acceptable values range from .51 to 255, default value is 1.2, out-of-range values will be clipped to the valid range.

radius is the neighborhood to fit the gradient to. A larger radius makes for smoother gradients, but also prevents the filter from modifying the pixels near detailed regions. Acceptable values are 8-32, default value is 16, out-of-range values will be clipped to the valid range.

    # default parameters
    gradfun=1.2:16

    # omitting radius
    gradfun=1.2

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.10 hflip

Flip the input video horizontally.

For example to horizontally flip the video in input with ‘`ffmpeg`’:

    ffmpeg -i in.avi -vf "hflip" out.avi

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.11 hqdn3d

High precision/quality 3d denoise filter. This filter aims to reduce image noise producing smooth images and making still images really still. It should enhance compressibility.

It accepts the following optional parameters: luma_spatial:chroma_spatial:luma_tmp:chroma_tmp

‘`luma_spatial`’

  a non-negative float number which specifies spatial luma strength, defaults to 4.0

‘`chroma_spatial`’

  a non-negative float number which specifies spatial chroma strength, defaults to 3.0*luma_spatial/4.0

‘`luma_tmp`’

  a float number which specifies luma temporal strength, defaults to 6.0*luma_spatial/4.0

‘`chroma_tmp`’

  a float number which specifies chroma temporal strength, defaults to luma_tmp*chroma_spatial/luma_spatial

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.12 noformat

Force libavfilter not to use any of the specified pixel formats for the input to the next filter.

The filter accepts a list of pixel format names, separated by ":", for example "yuv420p:monow:rgb24".

Some examples follow:

    # force libavfilter to use a format different from "yuv420p" for the
    # input to the vflip filter
    noformat=yuv420p,vflip

    # convert the input video to any of the formats not contained in the list
    noformat=yuv420p:yuv444p:yuv410p

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.13 null

Pass the video source unchanged to the output.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.14 ocv

Apply video transform using libopencv.

To enable this filter install libopencv library and headers and configure FFmpeg with –enable-libopencv.

The filter takes the parameters: filter_name{:=}filter_params.

filter_name is the name of the libopencv filter to apply.

filter_params specifies the parameters to pass to the libopencv filter. If not specified the default values are assumed.

Refer to the official libopencv documentation for more precise informations: http://opencv.willowgarage.com/documentation/c/image_filtering.html

Follows the list of supported libopencv filters.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

### 13.14.1 dilate

Dilate an image by using a specific structuring element. This filter corresponds to the libopencv function `cvDilate`.

It accepts the parameters: struct_el:nb_iterations.

struct_el represents a structuring element, and has the syntax: colsxrows+anchor_xxanchor_y/shape

cols and rows represent the number of colums and rows of the structuring element, anchor_x and anchor_y the anchor point, and shape the shape for the structuring element, and can be one of the values "rect", "cross", "ellipse", "custom".

If the value for shape is "custom", it must be followed by a string of the form "=filename". The file with name filename is assumed to represent a binary image, with each printable character corresponding to a bright pixel. When a custom shape is used, cols and rows are ignored, the number or columns and rows of the read file are assumed instead.

The default value for struct_el is "3x3+0x0/rect".

nb_iterations specifies the number of times the transform is applied to the image, and defaults to 1.

Follow some example:

    # use the default values
    ocv=dilate

    # dilate using a structuring element with a 5x5 cross, iterate two times
    ocv=dilate=5x5+2x2/cross:2

    # read the shape from the file diamond.shape, iterate two times
    # the file diamond.shape may contain a pattern of characters like this:
    #   *
    #  ***
    # *****
    #  ***
    #   *
    # the specified cols and rows are ignored (but not the anchor point coordinates)
    ocv=0x0+2x2/custom=diamond.shape:2

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

### 13.14.2 erode

Erode an image by using a specific structuring element. This filter corresponds to the libopencv function `cvErode`.

The filter accepts the parameters: struct_el:nb_iterations, with the same meaning and use of those of the dilate filter (see dilate).

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

### 13.14.3 smooth

Smooth the input video.

The filter takes the following parameters: type:param1:param2:param3:param4.

type is the type of smooth filter to apply, and can be one of the following values: "blur", "blur_no_scale", "median", "gaussian", "bilateral". The default value is "gaussian".

param1, param2, param3, and param4 are parameters whose meanings depend on smooth type. param1 and param2 accept integer positive values or 0, param3 and param4 accept float values.

The default value for param1 is 3, the default value for the other parameters is 0.

These parameters correspond to the parameters assigned to the libopencv function `cvSmooth`.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.15 overlay

Overlay one video on top of another.

It takes two inputs and one output, the first input is the "main" video on which the second input is overlayed.

It accepts the parameters: x:y.

x is the x coordinate of the overlayed video on the main video, y is the y coordinate. The parameters are expressions containing the following parameters:

‘`main_w, main_h`’

  main input width and height

‘`W, H`’

  same as main_w and main_h

‘`overlay_w, overlay_h`’

  overlay input width and height

‘`w, h`’

  same as overlay_w and overlay_h

Be aware that frames are taken from each input video in timestamp order, hence, if their initial timestamps differ, it is a a good idea to pass the two inputs through a setpts=PTS-STARTPTS filter to have them begin in the same zero timestamp, as it does the example for the movie filter.

Follow some examples:

    # draw the overlay at 10 pixels from the bottom right
    # corner of the main video.
    overlay=main_w-overlay_w-10:main_h-overlay_h-10

    # insert a transparent PNG logo in the bottom left corner of the input
    movie=0:png:logo.png [logo];
    [in][logo] overlay=10:main_h-overlay_h-10 [out]

    # insert 2 different transparent PNG logos (second logo on bottom
    # right corner):
    movie=0:png:logo1.png [logo1];
    movie=0:png:logo2.png [logo2];
    [in][logo1]       overlay=10:H-h-10 [in+logo1];
    [in+logo1][logo2] overlay=W-w-10:H-h-10 [out]

    # add a transparent color layer on top of the main video,
    # WxH specifies the size of the main input to the overlay filter
    color=red.3:WxH [over]; [in][over] overlay [out]

You can chain togheter more overlays but the efficiency of such approach is yet to be tested.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.16 pad

Add paddings to the input image, and places the original input at the given coordinates x, y.

It accepts the following parameters: width:height:x:y:color.

Follows the description of the accepted parameters.

‘`width, height`’

  Specify the size of the output image with the paddings added. If the value for width or height is 0, the corresponding input size is used for the output.

  The default value of width and height is 0.

‘`x, y`’

  Specify the offsets where to place the input image in the padded area with respect to the top/left border of the output image.

  The default value of x and y is 0.

‘`color`’

  Specify the color of the padded area, it can be the name of a color (case insensitive match) or a 0xRRGGBB[AA] sequence.

  The default value of color is "black".

For example:

    # Add paddings with color "violet" to the input video. Output video
    # size is 640x480, the top-left corner of the input video is placed at
    # row 0, column 40.
    pad=640:480:0:40:violet

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.17 pixdesctest

Pixel format descriptor test filter, mainly useful for internal testing. The output video should be equal to the input video.

For example:

    format=monow, pixdesctest

can be used to test the monowhite pixel format descriptor definition.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.18 scale

Scale the input video to width:height and/or convert the image format.

For example the command:

    ./ffmpeg -i in.avi -vf "scale=200:100" out.avi

will scale the input video to a size of 200x100.

If the input image format is different from the format requested by the next filter, the scale filter will convert the input to the requested format.

If the value for width or height is 0, the respective input size is used for the output.

If the value for width or height is -1, the scale filter will use, for the respective output size, a value that maintains the aspect ratio of the input image.

The default value of width and height is 0.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.19 setpts

Change the PTS (presentation timestamp) of the input video frames.

Accept in input an expression evaluated through the eval API, which can contain the following constants:

‘`PTS`’

  the presentation timestamp in input

‘`PI`’

  Greek PI

‘`PHI`’

  golden ratio

‘`E`’

  Euler number

‘`N`’

  the count of the input frame, starting from 0.

‘`STARTPTS`’

  the PTS of the first video frame

‘`INTERLACED`’

  tell if the current frame is interlaced

‘`POS`’

  original position in the file of the frame, or undefined if undefined for the current frame

‘`PREV_INPTS`’

  previous input PTS

‘`PREV_OUTPTS`’

  previous output PTS

Some examples follow:

    # start counting PTS from zero
    setpts=PTS-STARTPTS

    # fast motion
    setpts=0.5*PTS

    # slow motion
    setpts=2.0*PTS

    # fixed rate 25 fps
    setpts=N/(25*TB)

    # fixed rate 25 fps with some jitter
    setpts='1/(25*TB) * (N + 0.05 * sin(N*2*PI/25))'

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.20 settb

Set the timebase to use for the output frames timestamps. It is mainly useful for testing timebase configuration.

It accepts in input an arithmetic expression representing a rational. The expression can contain the constants "PI", "E", "PHI", "AVTB" (the default timebase), and "intb" (the input timebase).

The default value for the input is "intb".

Follow some examples.

    # set the timebase to 1/25
    settb=1/25

    # set the timebase to 1/10
    settb=0.1

    #set the timebase to 1001/1000
    settb=1+0.001

    #set the timebase to 2*intb
    settb=2*intb

    #set the default timebase value
    settb=AVTB

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.21 slicify

Pass the images of input video on to next video filter as multiple slices.

    ./ffmpeg -i in.avi -vf "slicify=32" out.avi

The filter accepts the slice height as parameter. If the parameter is not specified it will use the default value of 16.

Adding this in the beginning of filter chains should make filtering faster due to better use of the memory cache.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.22 transpose

Transpose rows with columns in the input video and optionally flip it.

It accepts a parameter representing an integer, which can assume the values:

‘`0`’

  Rotate by 90 degrees counterclockwise and vertically flip (default), that is:

      L.R     L.l
      . . ->  . .
      l.r     R.r

‘`1`’

  Rotate by 90 degrees clockwise, that is:

      L.R     l.L
      . . ->  . .
      l.r     r.R

‘`2`’

  Rotate by 90 degrees counterclockwise, that is:

      L.R     R.r
      . . ->  . .
      l.r     L.l

‘`3`’

  Rotate by 90 degrees clockwise and vertically flip, that is:

      L.R     r.R
      . . ->  . .
      l.r     l.L

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.23 unsharp

Sharpen or blur the input video.

It accepts the following parameters: luma_msize_x:luma_msize_y:luma_amount:chroma_msize_x:chroma_msize_y:chroma_amount

Negative values for the amount will blur the input video, while positive values will sharpen. All parameters are optional and default to the equivalent of the string '5:5:1.0:0:0:0.0'.

‘`luma_msize_x`’

  Set the luma matrix horizontal size. It can be an integer between 3 and 13, default value is 5.

‘`luma_msize_y`’

  Set the luma matrix vertical size. It can be an integer between 3 and 13, default value is 5.

‘`luma_amount`’

  Set the luma effect strength. It can be a float number between -2.0 and 5.0, default value is 1.0.

‘`chroma_msize_x`’

  Set the chroma matrix horizontal size. It can be an integer between 3 and 13, default value is 0.

‘`chroma_msize_y`’

  Set the chroma matrix vertical size. It can be an integer between 3 and 13, default value is 0.

‘`luma_amount`’

  Set the chroma effect strength. It can be a float number between -2.0 and 5.0, default value is 0.0.

    # Strong luma sharpen effect parameters
    unsharp=7:7:2.5

    # Strong blur of both luma and chroma parameters
    unsharp=7:7:-2:7:7:-2

    # Use the default values with ffmpeg
    ./ffmpeg -i in.avi -vf "unsharp" out.mp4

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.24 vflip

Flip the input video vertically.

    ./ffmpeg -i in.avi -vf "vflip" out.avi

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 13.25 yadif

Deinterlace the input video ("yadif" means "yet another deinterlacing filter").

It accepts the optional parameters: mode:parity.

mode specifies the interlacing mode to adopt, accepts one of the following values:

‘`0`’

  output 1 frame for each frame

‘`1`’

  output 1 frame for each field

‘`2`’

  like 0 but skips spatial interlacing check

‘`3`’

  like 1 but skips spatial interlacing check

Default value is 0.

parity specifies the picture field parity assumed for the input interlaced video, accepts one of the following values:

‘`0`’

  assume bottom field first

‘`1`’

  assume top field first

‘`-1`’

  enable automatic detection

Default value is -1. If interlacing is unknown or decoder does not export this information, top field first will be assumed.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 14. Video Sources

Below is a description of the currently available video sources.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 14.1 buffer

Buffer video frames, and make them available to the filter chain.

This source is mainly intended for a programmatic use, in particular through the interface defined in ‘`libavfilter/vsrc_buffer.h`’.

It accepts the following parameters: width:height:pix_fmt_string:timebase_num:timebase_den

All the parameters need to be explicitely defined.

Follows the list of the accepted parameters.

‘`width, height`’

  Specify the width and height of the buffered video frames.

‘`pix_fmt_string`’

  A string representing the pixel format of the buffered video frames. It may be a number corresponding to a pixel format, or a pixel format name.

‘`timebase_num, timebase_den`’

  Specify numerator and denomitor of the timebase assumed by the timestamps of the buffered frames.

For example:

    buffer=320:240:yuv410p:1:24

will instruct the source to accept video frames with size 320x240 and with format "yuv410p" and assuming 1/24 as the timestamps timebase. Since the pixel format with name "yuv410p" corresponds to the number 6 (check the enum PixelFormat definition in ‘`libavutil/pixfmt.h`’), this example corresponds to:

    buffer=320:240:6:1:24

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 14.2 color

Provide an uniformly colored input.

It accepts the following parameters: color:frame_size:frame_rate

Follows the description of the accepted parameters.

‘`color`’

  Specify the color of the source. It can be the name of a color (case insensitive match) or a 0xRRGGBB[AA] sequence, possibly followed by an alpha specifier. The default value is "black".

‘`frame_size`’

  Specify the size of the sourced video, it may be a string of the form widthxheigth, or the name of a size abbreviation. The default value is "320x240".

‘`frame_rate`’

  Specify the frame rate of the sourced video, as the number of frames generated per second. It has to be a string in the format frame_rate_num/frame_rate_den, an integer number, a float number or a valid video frame rate abbreviation. The default value is "25".

For example the following graph description will generate a red source with an opacity of 0.2, with size "qcif" and a frame rate of 10 frames per second, which will be overlayed over the source connected to the pad with identifier "in".

    "color=red@0.2:qcif:10 [color]; [in][color] overlay [out]"

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 14.3 nullsrc

Null video source, never return images. It is mainly useful as a template and to be employed in analysis / debugging tools.

It accepts as optional parameter a string of the form width:height:timebase.

width and height specify the size of the configured source. The default values of width and height are respectively 352 and 288 (corresponding to the CIF size format).

timebase specifies an arithmetic expression representing a timebase. The expression can contain the constants "PI", "E", "PHI", "AVTB" (the default timebase), and defaults to the value "AVTB".

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 14.4 frei0r_src

Provide a frei0r source.

To enable compilation of this filter you need to install the frei0r header and configure FFmpeg with –enable-frei0r.

The source supports the syntax:

    size:rate:src_name[{=|:}param1:param2:...:paramN]

size is the size of the video to generate, may be a string of the form widthxheight or a frame size abbreviation. rate is the rate of the video to generate, may be a string of the form num/den or a frame rate abbreviation. src_name is the name to the frei0r source to load. For more information regarding frei0r and how to set the parameters read the section "frei0r" (see frei0r) in the description of the video filters.

Some examples follow:

    # generate a frei0r partik0l source with size 200x200 and framerate 10
    # which is overlayed on the overlay filter main input
    frei0r_src=200x200:10:partik0l=1234 [overlay]; [in][overlay] overlay

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 15. Video Sinks

Below is a description of the currently available video sinks.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 15.1 nullsink

Null video sink, do absolutely nothing with the input video. It is mainly useful as a template and to be employed in analysis / debugging tools.

[Top] | [Contents] | [Index] | [ ? ]

# About This Document

This document was generated on January, 17 2011 using texi2html 1.78.

The buttons in the navigation panels have the following meaning:

Button | Name | Go to | From 1.2.3 go to
--- | --- | --- | ---
[ < ] | Back | Previous section in reading order | 1.2.2
[ > ] | Forward | Next section in reading order | 1.2.4
[ << ] | FastBack | Beginning of this chapter or previous chapter | 1
[ Up ] | Up | Up section | 1.2
[ >> ] | FastForward | Next chapter | 2
[Top] | Top | Cover (top) of document |
[Contents] | Contents | Table of contents |
[Index] | Index | Index |
[ ? ] | About | About (help) |

where the Example assumes that the current position is at Subsubsection One-Two-Three of a document of the following structure:

- 1. Section One
  - 1.1 Subsection One-One
    - ...
  - 1.2 Subsection One-Two
    - 1.2.1 Subsubsection One-Two-One
    - 1.2.2 Subsubsection One-Two-Two
    - 1.2.3 Subsubsection One-Two-Three <== Current Position
    - 1.2.4 Subsubsection One-Two-Four
  - 1.3 Subsection One-Three
    - ...
  - 1.4 Subsection One-Four

This document was generated on January, 17 2011 using texi2html 1.78.